#include <cstdio>
#include <iostream>
#include "io.h"

// put implementation only (private) interface here
namespace Mylib {
}

void Mylib::InFopen(ifstream & infile, const char * fname) throw(FileOpenErr)
{
  infile.close();
  infile.clear();
  infile.open(fname);
  if (! infile.good()) {
    cerr << "Error: can't open " << fname << endl;
    throw FileOpenErr();
  }
}

void Mylib::InFopen(ifstream & infile, const string & fname) throw(FileOpenErr)
{
  infile.close();
  infile.clear();
  infile.open(fname.c_str());
  if (! infile.good()) {
    cerr << "Error: can't open " << fname << endl;
    throw FileOpenErr();
  }
}

void Mylib::OutFopen(ofstream & outfile, const char * fname) throw(FileOpenErr, FilExistErr)
{
  FILE * tmpf;
  char buffer[1000];

  outfile.close();
  outfile.clear();
  strcpy(buffer, fname);
  buffer[5] = '\0';
  // don't worry about overwrite if it's in /tmp/ or /dev/ including /dev/stdout for cout
  if (strcmp(buffer, "/dev/") != 0 && strcmp(buffer, "/tmp/") != 0) {
    tmpf = fopen(fname, "r");
    if (tmpf != NULL) {
      cerr << "Error: file already exists: " << fname << endl;
      throw FilExistErr();
    }
  }
  outfile.open(fname);
  if (! outfile.good()) {
    cerr << "Error: can't open " << fname << endl;
    throw FileOpenErr();
  }
}

void Mylib::PrintJoin(ostream & out, const vector<int> & data, const char * sep)
{
  int i;
  if (data.size() == 0) {
    return;
  }
  out << data[0];
  for (i = 1; i < data.size(); i++) {
    out << sep << data[i];
  }
}

void Mylib::PrintJoin(ostream & out, const vector<double> & data, const char * sep)
{
  int i;
  if (data.size() == 0) {
    return;
  }
  out << data[0];
  for (i = 1; i < data.size(); i++) {
    out << sep << data[i];
  }
}

void Mylib::PrintJoin(ostream & out, const set<int> & data, const char * sep)
{
  set<int>::const_iterator si;
  if (data.size() == 0) {
    return;
  }
  for (si = data.begin(); si != data.end(); si++) {
    if (si != data.begin()) {
      out << sep;
    }
    out << *si;
  }
}

void Mylib::PrintJoin(ostream & out, const set<double> & data, const char * sep)
{
  set<double>::const_iterator si;
  if (data.size() == 0) {
    return;
  }
  for (si = data.begin(); si != data.end(); si++) {
    if (si != data.begin()) {
      out << sep;
    }
    out << *si;
  }
}
