#ifndef _MYCLIB_MATH_H
#define _MYCLIB_MATH_H

#include <vector>
#include <cassert>
using namespace std;

// put user (public) interface here
namespace Mylib {
  const double PI = 3.14159;
  double DotProd(const vector<double> & d1, const vector<double> & d2);
  double Mean(const vector<double> & vs);
  // sum of square of vs-mean
  double Sqsum(const vector<double> & vs, double mean);
  // mean of square of vs-mean. If 'mean' is mean of vs, it's variance
  double Var(const vector<double> & vs, double mean);
  // normalize the values in vs so it sum up to 1
  void NormalizeL1(vector<double> & vs);
  // return log(\sum_{exp(vs[i])})
  double LogSum(const vector<double> & vs);
  // Both v1s and v2s are sorted from small to large. Merge them to vs so it's still sorted and has only unique elements
  void SortMerge(vector<double> & vs, const vector<double> & v1s, const vector<double> & v2s);
}

#endif
